//+------------------------------------------------------------------+
//|                                                      MACD T3.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers   4
#property indicator_color1    LimeGreen
#property indicator_color2    Red
#property indicator_color3    DimGray
#property indicator_color4    Gold
#property indicator_width1    3
#property indicator_width2    3
#property indicator_width3    3

//
//
//
//
//
//

extern int    FastPeriod      = 12;
extern int    SlowPeriod      = 26;
extern int    SignalPeriod    =  9;
extern int    AppliedPrice    = PRICE_CLOSE;
extern double T3Hot           = 0.618;
extern bool   T3Original      = false;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsPushNotif = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double macd[];
double macdhU[];
double macdhD[];
double signal[];
double trend[];

//
//
//
//
//

double emas[][18];
double alphaFast;
double alphaSlow;
double alphaSignal;
double c1;
double c2;
double c3;
double c4;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0, macdhU);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, macdhD);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, macd);
   SetIndexBuffer(3, signal);
   SetIndexBuffer(4, trend);

   //
   //
   //
   //
   //
   
      double a  = T3Hot;
             c1 = -a*a*a;
             c2 =  3*(a*a+a*a*a);
             c3 = -3*(2*a*a+a+a*a*a);
             c4 = 1+3*a+a*a*a+3*a*a;

   //
   //
   //
   //
   //
   
      FastPeriod   = MathMax(1,FastPeriod);
      SlowPeriod   = MathMax(1,SlowPeriod);
      SignalPeriod = MathMax(1,SignalPeriod);
      if (T3Original)
         {
            alphaFast   = 2.0/(1.0 + FastPeriod);
            alphaSlow   = 2.0/(1.0 + SlowPeriod);
            alphaSignal = 2.0/(1.0 + SignalPeriod);
         }            
      else
         {
            alphaFast   = 2.0/(2.0 + (FastPeriod-1.0)/2.0);
            alphaSlow   = 2.0/(2.0 + (SlowPeriod-1.0)/2.0);
            alphaSignal = 2.0/(2.0 + (SignalPeriod-1.0)/2.0);
         }            

   //
   //
   //    
   //
   //

   IndicatorShortName("MACD ("+FastPeriod+","+SlowPeriod+")");
   return(0);
}
int deinit()
{
   return(0);
}  

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int i,limit;


   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) 
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,AppliedPrice,i);
         macd[i]   = iT3(price,alphaFast,0,i)-iT3(price,alphaSlow,6,i);
         signal[i] = iT3(macd[i],alphaSignal,12,i);
         trend[i]  = trend[i+1];
         macdhU[i] = EMPTY_VALUE;
         macdhD[i] = EMPTY_VALUE;
         
         if (macd[i]>macd[i+1]) trend[i] =  1;
         if (macd[i]<macd[i+1]) trend[i] = -1;
            if (trend[i]== 1) macdhU[i] = macd[i];
            if (trend[i]==-1) macdhD[i] = macd[i];
   }
   manageAlerts();
   
   //
   //
   //
   //
   //
      
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iT3(double price,double alpha,int buffer,int shift)
{
   int i = Bars-shift-1;
   if (i < 1)
      {
         emas[i][0+buffer] = price;
         emas[i][1+buffer] = price;
         emas[i][2+buffer] = price;
         emas[i][3+buffer] = price;
         emas[i][4+buffer] = price;
         emas[i][5+buffer] = price;
      }
   else
      {
         emas[i][0+buffer] = emas[i-1][0+buffer]+alpha*(price            -emas[i-1][0+buffer]);
         emas[i][1+buffer] = emas[i-1][1+buffer]+alpha*(emas[i][0+buffer]-emas[i-1][1+buffer]);
         emas[i][2+buffer] = emas[i-1][2+buffer]+alpha*(emas[i][1+buffer]-emas[i-1][2+buffer]);
         emas[i][3+buffer] = emas[i-1][3+buffer]+alpha*(emas[i][2+buffer]-emas[i-1][3+buffer]);
         emas[i][4+buffer] = emas[i-1][4+buffer]+alpha*(emas[i][3+buffer]-emas[i-1][4+buffer]);
         emas[i][5+buffer] = emas[i-1][5+buffer]+alpha*(emas[i][4+buffer]-emas[i-1][5+buffer]);
      }
   return(c1*emas[i][5+buffer] + c2*emas[i][4+buffer] + c3*emas[i][3+buffer] + c4*emas[i][2+buffer]);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," T3 MACD slope changed to ",doWhat);
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," T3 MACD"),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," T3 MACD "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}